/**
 * Copyright (c) 2010-2020 Contributors to the openHAB project
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0
 *
 * SPDX-License-Identifier: EPL-2.0
 */

/* ***********************************************************
* This file was automatically generated on 2020-05-19.      *
*                                                           *
* openHAB Bindings Version 2.0.0                            *
*                                                           *
* If you have a bugfix for this file and want to commit it, *
* please fix the bug in the generator. You can find a link  *
* to the generators git repository on tinkerforge.com       *
*************************************************************/

package org.openhab.binding.tinkerforge.internal.device;

import java.util.HashMap;
import java.util.Map;

import org.eclipse.jdt.annotation.NonNullByDefault;
import org.eclipse.jdt.annotation.Nullable;
import org.eclipse.smarthome.core.thing.binding.ThingActions;
import org.eclipse.smarthome.core.thing.binding.ThingActionsScope;
import org.eclipse.smarthome.core.thing.binding.ThingHandler;
import org.openhab.binding.tinkerforge.internal.handler.DeviceHandler;
import org.openhab.core.automation.annotation.ActionInput;
import org.openhab.core.automation.annotation.ActionOutput;
import org.openhab.core.automation.annotation.RuleAction;

import com.tinkerforge.BrickletRGBLEDMatrix;
import com.tinkerforge.TinkerforgeException;

/**
 * Passes through actions of the RGB LED Matrix Bricklet.
 * 
 * @author Erik Fleckstein - Initial contribution
 */
@ThingActionsScope(name = "tinkerforge")
@NonNullByDefault
public class BrickletRGBLEDMatrixActions implements ThingActions {

    private @Nullable DeviceHandler handler;

    @Override
    public void setThingHandler(@Nullable ThingHandler handler) {
        this.handler = (DeviceHandler) handler;
    }

    @Override
    public @Nullable ThingHandler getThingHandler() {
        return handler;
    }

    @RuleAction(label = "Get Red")
    public @ActionOutput(name = "red", type = "int[]") Map<String, Object> brickletRGBLEDMatrixGetRed()
            throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if (h == null) {
            return result;
        }

        @Nullable
        BrickletRGBLEDMatrixWrapper dev = ((@Nullable BrickletRGBLEDMatrixWrapper) h.getDevice());
        if (dev == null) {
            return result;
        }

        int[] value = dev.getRed();

        result.put("red", value);
        return result;
    }

    public static Map<String, Object> brickletRGBLEDMatrixGetRed(@Nullable ThingActions actions)
            throws TinkerforgeException {
        if (actions instanceof BrickletRGBLEDMatrixActions) {
            return ((BrickletRGBLEDMatrixActions) actions).brickletRGBLEDMatrixGetRed();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletRGBLEDMatrixActions class.");
        }
    }

    @RuleAction(label = "Get Green")
    public @ActionOutput(name = "green", type = "int[]") Map<String, Object> brickletRGBLEDMatrixGetGreen()
            throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if (h == null) {
            return result;
        }

        @Nullable
        BrickletRGBLEDMatrixWrapper dev = ((@Nullable BrickletRGBLEDMatrixWrapper) h.getDevice());
        if (dev == null) {
            return result;
        }

        int[] value = dev.getGreen();

        result.put("green", value);
        return result;
    }

    public static Map<String, Object> brickletRGBLEDMatrixGetGreen(@Nullable ThingActions actions)
            throws TinkerforgeException {
        if (actions instanceof BrickletRGBLEDMatrixActions) {
            return ((BrickletRGBLEDMatrixActions) actions).brickletRGBLEDMatrixGetGreen();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletRGBLEDMatrixActions class.");
        }
    }

    @RuleAction(label = "Get Blue")
    public @ActionOutput(name = "blue", type = "int[]") Map<String, Object> brickletRGBLEDMatrixGetBlue()
            throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if (h == null) {
            return result;
        }

        @Nullable
        BrickletRGBLEDMatrixWrapper dev = ((@Nullable BrickletRGBLEDMatrixWrapper) h.getDevice());
        if (dev == null) {
            return result;
        }

        int[] value = dev.getBlue();

        result.put("blue", value);
        return result;
    }

    public static Map<String, Object> brickletRGBLEDMatrixGetBlue(@Nullable ThingActions actions)
            throws TinkerforgeException {
        if (actions instanceof BrickletRGBLEDMatrixActions) {
            return ((BrickletRGBLEDMatrixActions) actions).brickletRGBLEDMatrixGetBlue();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletRGBLEDMatrixActions class.");
        }
    }

    @RuleAction(label = "Set Red")
    public void brickletRGBLEDMatrixSetRed(@ActionInput(name = "red") int[] red) throws TinkerforgeException {
        DeviceHandler h = handler;
        if (h == null) {
            return;
        }

        @Nullable
        BrickletRGBLEDMatrixWrapper dev = ((@Nullable BrickletRGBLEDMatrixWrapper) h.getDevice());
        if (dev == null) {
            return;
        }
        dev.setRed(red);
    }

    public static void brickletRGBLEDMatrixSetRed(@Nullable ThingActions actions, int[] red)
            throws TinkerforgeException {
        if (actions instanceof BrickletRGBLEDMatrixActions) {
            ((BrickletRGBLEDMatrixActions) actions).brickletRGBLEDMatrixSetRed(red);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletRGBLEDMatrixActions class.");
        }
    }

    @RuleAction(label = "Set Green")
    public void brickletRGBLEDMatrixSetGreen(@ActionInput(name = "green") int[] green) throws TinkerforgeException {
        DeviceHandler h = handler;
        if (h == null) {
            return;
        }

        @Nullable
        BrickletRGBLEDMatrixWrapper dev = ((@Nullable BrickletRGBLEDMatrixWrapper) h.getDevice());
        if (dev == null) {
            return;
        }
        dev.setGreen(green);
    }

    public static void brickletRGBLEDMatrixSetGreen(@Nullable ThingActions actions, int[] green)
            throws TinkerforgeException {
        if (actions instanceof BrickletRGBLEDMatrixActions) {
            ((BrickletRGBLEDMatrixActions) actions).brickletRGBLEDMatrixSetGreen(green);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletRGBLEDMatrixActions class.");
        }
    }

    @RuleAction(label = "Set Blue")
    public void brickletRGBLEDMatrixSetBlue(@ActionInput(name = "blue") int[] blue) throws TinkerforgeException {
        DeviceHandler h = handler;
        if (h == null) {
            return;
        }

        @Nullable
        BrickletRGBLEDMatrixWrapper dev = ((@Nullable BrickletRGBLEDMatrixWrapper) h.getDevice());
        if (dev == null) {
            return;
        }
        dev.setBlue(blue);
    }

    public static void brickletRGBLEDMatrixSetBlue(@Nullable ThingActions actions, int[] blue)
            throws TinkerforgeException {
        if (actions instanceof BrickletRGBLEDMatrixActions) {
            ((BrickletRGBLEDMatrixActions) actions).brickletRGBLEDMatrixSetBlue(blue);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletRGBLEDMatrixActions class.");
        }
    }

    @RuleAction(label = "Get Frame Duration")
    public @ActionOutput(name = "frameDuration", type = "int") Map<String, Object> brickletRGBLEDMatrixGetFrameDuration()
            throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if (h == null) {
            return result;
        }

        @Nullable
        BrickletRGBLEDMatrixWrapper dev = ((@Nullable BrickletRGBLEDMatrixWrapper) h.getDevice());
        if (dev == null) {
            return result;
        }

        int value = dev.getFrameDuration();

        result.put("frameDuration", value);
        return result;
    }

    public static Map<String, Object> brickletRGBLEDMatrixGetFrameDuration(@Nullable ThingActions actions)
            throws TinkerforgeException {
        if (actions instanceof BrickletRGBLEDMatrixActions) {
            return ((BrickletRGBLEDMatrixActions) actions).brickletRGBLEDMatrixGetFrameDuration();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletRGBLEDMatrixActions class.");
        }
    }

    @RuleAction(label = "Draw Frame")
    public void brickletRGBLEDMatrixDrawFrame() throws TinkerforgeException {
        DeviceHandler h = handler;
        if (h == null) {
            return;
        }

        @Nullable
        BrickletRGBLEDMatrixWrapper dev = ((@Nullable BrickletRGBLEDMatrixWrapper) h.getDevice());
        if (dev == null) {
            return;
        }
        dev.drawFrame();
    }

    public static void brickletRGBLEDMatrixDrawFrame(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletRGBLEDMatrixActions) {
            ((BrickletRGBLEDMatrixActions) actions).brickletRGBLEDMatrixDrawFrame();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletRGBLEDMatrixActions class.");
        }
    }

    @RuleAction(label = "Get Supply Voltage")
    public @ActionOutput(name = "voltage", type = "int") Map<String, Object> brickletRGBLEDMatrixGetSupplyVoltage()
            throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if (h == null) {
            return result;
        }

        @Nullable
        BrickletRGBLEDMatrixWrapper dev = ((@Nullable BrickletRGBLEDMatrixWrapper) h.getDevice());
        if (dev == null) {
            return result;
        }

        int value = dev.getSupplyVoltage();

        result.put("voltage", value);
        return result;
    }

    public static Map<String, Object> brickletRGBLEDMatrixGetSupplyVoltage(@Nullable ThingActions actions)
            throws TinkerforgeException {
        if (actions instanceof BrickletRGBLEDMatrixActions) {
            return ((BrickletRGBLEDMatrixActions) actions).brickletRGBLEDMatrixGetSupplyVoltage();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletRGBLEDMatrixActions class.");
        }
    }

    @RuleAction(label = "Read UID")
    public @ActionOutput(name = "uid", type = "long") Map<String, Object> brickletRGBLEDMatrixReadUID()
            throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if (h == null) {
            return result;
        }

        @Nullable
        BrickletRGBLEDMatrixWrapper dev = ((@Nullable BrickletRGBLEDMatrixWrapper) h.getDevice());
        if (dev == null) {
            return result;
        }

        long value = dev.readUID();

        result.put("uid", value);
        return result;
    }

    public static Map<String, Object> brickletRGBLEDMatrixReadUID(@Nullable ThingActions actions)
            throws TinkerforgeException {
        if (actions instanceof BrickletRGBLEDMatrixActions) {
            return ((BrickletRGBLEDMatrixActions) actions).brickletRGBLEDMatrixReadUID();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletRGBLEDMatrixActions class.");
        }
    }

    @RuleAction(label = "Get Chip Temperature")
    public @ActionOutput(name = "temperature", type = "int") Map<String, Object> brickletRGBLEDMatrixGetChipTemperature()
            throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if (h == null) {
            return result;
        }

        @Nullable
        BrickletRGBLEDMatrixWrapper dev = ((@Nullable BrickletRGBLEDMatrixWrapper) h.getDevice());
        if (dev == null) {
            return result;
        }

        int value = dev.getChipTemperature();

        result.put("temperature", value);
        return result;
    }

    public static Map<String, Object> brickletRGBLEDMatrixGetChipTemperature(@Nullable ThingActions actions)
            throws TinkerforgeException {
        if (actions instanceof BrickletRGBLEDMatrixActions) {
            return ((BrickletRGBLEDMatrixActions) actions).brickletRGBLEDMatrixGetChipTemperature();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletRGBLEDMatrixActions class.");
        }
    }

    @RuleAction(label = "Get Status LED Config")
    public @ActionOutput(name = "config", type = "int") Map<String, Object> brickletRGBLEDMatrixGetStatusLEDConfig()
            throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if (h == null) {
            return result;
        }

        @Nullable
        BrickletRGBLEDMatrixWrapper dev = ((@Nullable BrickletRGBLEDMatrixWrapper) h.getDevice());
        if (dev == null) {
            return result;
        }

        int value = dev.getStatusLEDConfig();

        result.put("config", value);
        return result;
    }

    public static Map<String, Object> brickletRGBLEDMatrixGetStatusLEDConfig(@Nullable ThingActions actions)
            throws TinkerforgeException {
        if (actions instanceof BrickletRGBLEDMatrixActions) {
            return ((BrickletRGBLEDMatrixActions) actions).brickletRGBLEDMatrixGetStatusLEDConfig();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletRGBLEDMatrixActions class.");
        }
    }

    @RuleAction(label = "Get SPITFP Error Count")
    public @ActionOutput(name = "errorCountAckChecksum", type = "long") @ActionOutput(name = "errorCountMessageChecksum", type = "long") @ActionOutput(name = "errorCountFrame", type = "long") @ActionOutput(name = "errorCountOverflow", type = "long") Map<String, Object> brickletRGBLEDMatrixGetSPITFPErrorCount()
            throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if (h == null) {
            return result;
        }

        @Nullable
        BrickletRGBLEDMatrixWrapper dev = ((@Nullable BrickletRGBLEDMatrixWrapper) h.getDevice());
        if (dev == null) {
            return result;
        }

        BrickletRGBLEDMatrix.SPITFPErrorCount value = dev.getSPITFPErrorCount();

        result.put("errorCountAckChecksum", value.errorCountAckChecksum);
        result.put("errorCountMessageChecksum", value.errorCountMessageChecksum);
        result.put("errorCountFrame", value.errorCountFrame);
        result.put("errorCountOverflow", value.errorCountOverflow);
        return result;
    }

    public static Map<String, Object> brickletRGBLEDMatrixGetSPITFPErrorCount(@Nullable ThingActions actions)
            throws TinkerforgeException {
        if (actions instanceof BrickletRGBLEDMatrixActions) {
            return ((BrickletRGBLEDMatrixActions) actions).brickletRGBLEDMatrixGetSPITFPErrorCount();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletRGBLEDMatrixActions class.");
        }
    }

    @RuleAction(label = "Get Identity")
    public @ActionOutput(name = "uid", type = "String") @ActionOutput(name = "connectedUid", type = "String") @ActionOutput(name = "position", type = "char") @ActionOutput(name = "hardwareVersion", type = "short[]") @ActionOutput(name = "firmwareVersion", type = "short[]") @ActionOutput(name = "deviceIdentifier", type = "int") Map<String, Object> brickletRGBLEDMatrixGetIdentity()
            throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if (h == null) {
            return result;
        }

        @Nullable
        BrickletRGBLEDMatrixWrapper dev = ((@Nullable BrickletRGBLEDMatrixWrapper) h.getDevice());
        if (dev == null) {
            return result;
        }

        BrickletRGBLEDMatrix.Identity value = dev.getIdentity();

        result.put("uid", value.uid);
        result.put("connectedUid", value.connectedUid);
        result.put("position", value.position);
        result.put("hardwareVersion", value.hardwareVersion);
        result.put("firmwareVersion", value.firmwareVersion);
        result.put("deviceIdentifier", value.deviceIdentifier);
        return result;
    }

    public static Map<String, Object> brickletRGBLEDMatrixGetIdentity(@Nullable ThingActions actions)
            throws TinkerforgeException {
        if (actions instanceof BrickletRGBLEDMatrixActions) {
            return ((BrickletRGBLEDMatrixActions) actions).brickletRGBLEDMatrixGetIdentity();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletRGBLEDMatrixActions class.");
        }
    }
}
